Migrate System Tests from Selenium to Playwright
2024-08-06 03:06 - Mizuki ISHIKAWA

Status: New Start date:

Priority: Normal Due date:

Assignee: Marius BALTEANU % Done: 0%
Category: Code cleanup/refactoring Estimated time: 0.00 hour
Target version: Candidate for next major release

Description

Currently, Redmine executes system tests using Selenium. | suggestion to switch to Playwright for running these tests.

Playwright can be used as a driver starting from Rails 7.1.
https://github.com/rails/rails/pull/48950

Before running the tests, several commands need to be executed:
e yarn install
e npx playwright install
¢ npx playwright install-deps

Benefits of using Playwright:

e Simpler setup process
¢ Capybara syntax available ( https:/github.com/Yusukelwaki/capybara-playwright-driver )

Drawbacks of using Playwright:

e Migration from the existing Selenium environment is required (not needed if using the playwright_or_selenium.patch)
e Commands to set up Playwright need to be executed before running the tests

| have attached two patches: playwright.patch and playwright_or_selenium.patch. The playwright.patch replaces Selenium with
Playwright, while the playwright_or_selenium.patch switches the driver based on the ENV['USE_PLAYWRIGHT]. Please let us know
your thoughts on which option is preferable.

History

#1 - 2024-08-06 03:07 - Mizuki ISHIKAWA
- File playwright_or_selenium_v2.patch added

#2 - 2024-08-06 03:17 - Mizuki ISHIKAWA

tests run with Playwright:

$ USE_PLAYWRIGHT=true rake test TEST=test/system/

To run the system test using Playwright, the following commands are required in advance.
‘yarn install®

‘npx playwright install®

‘npx playwright install-deps’

Run options: --seed 56757

# Running:

Capybara starting Puma...

* Version 6.4.2, codename: The Eagle of Durango

* Min threads: 0, max threads: 4
* Listening on http://127.0.0.1:41937

....... [Screenshot Imagel: /var/lib/redmine/tmp/downloads/failures_test_inline_autocomplete_for_issues_with_do
uble_hash_keep_syntax.png

E

Error:

InlineAutocompleteSystemTest#test_inline_autocomplete_for_issues_with_double_hash_keep_syntax:
Capybara: :ElementNotFound: Unable to find visible css ".tribute-container"
test/system/inline_autocomplete_test.rb:54:in “test_inline_autocomplete_for_issues_with_double_hash_keep_s
yntax'

bin/rails test test/system/inline_autocomplete_test.rb:47

....................................... [WARNING] Execution context was destroyed, most likely because of a nav

... [WARNING] Execution context was destroyed, most likely because of a navigation
Call log:

Finished in 100.760690s, 0.6153 runs/s, 3.7812 assertions/s.
62 runs, 381 assertions, 0 failures, 1 errors, 0 skips

InlineAutocompleteSystemTest#test_inline_autocomplete_for_issues_with_double_hash_keep_syntax test seems to fail in selenium too.

#3 - 2024-08-06 05:09 - Ko Nagase
+1 for playwright_or_selenium option, because some plugins may still need selenium setup in redmine core side.
| confirmed that playwright_or_selenium_v2.patch doesn't affect selenium test results.

In addition of the above error which seems to be same as #40683,
| confirmed the following failure on both playwright and selenium tests,
but | guess that it comes from my test environment (macOS armé4, ruby3.2, PostgreSQL14).

Failure:

IssuesSystemTestf#test_create_issue_with_watchers [test/system/issues_test.rb:137]:
—-—— expected

+++ actual

@@ -1 +1 @@

—["Dave Lopper", "Some Watcher"]

+["Dave Lopper", "John Smith", "Some Watcher"]

#4 - 2024-10-24 08:26 - Mizuki ISHIKAWA
- File playwright_or_selenium_v3.patch added

| have updated the patch to work with the latest Redmine.
| would be glad to get this patch committed, as it is hard to create a system testing environment using selenium in my development environment (Mac
M1, using Docker).

#5 - 2024-11-10 08:43 - Go MAEDA

- Target version set to Candidate for next major release

#6 - 2024-11-10 22:30 - Marius BALTEANU

Have you made this work inside a Docker container?

#7 - 2024-11-15 08:55 - Mizuki ISHIKAWA
Marius BALTEANU wrote in #note-6:

Have you made this work inside a Docker container?

Yes, Playwright tests can be run inside a Docker container. For example, if you want to integrate it into GitHub Actions, it can be set up like this:
https://github.com/ishikawa999/redmine/actions/runs/11852263582/workflow#L 103-L116 ,
https://qgithub.com/ishikawa999/redmine/actions/runs/11852263582/job/33030121847.

#8 - 2024-11-15 08:59 - Marius BALTEANU
- Assignee set to Marius BALTEANU

Files

playwright_or_selenium.patch 72.2 KB 2024-08-06 Mizuki ISHIKAWA
playwright.patch 70.9 KB 2024-08-06 Mizuki ISHIKAWA
playwright_or_selenium_v2.patch 72.2 KB 2024-08-06 Mizuki ISHIKAWA
